#define FRAC32(x) ((Frac32)((x) < 1 ? ((x) >= -1 ? (x)*0x80000000 : 0x80000000) : 0x7FFFFFFF))
#define	N	128
#define	M	7
#define N_1 FRAC16(0.0078125)  //1/N
#define N_1_32 FRAC32(0.0078125)  //1/N
#define full	2
#define empty   1
#define	run		3
#define done	4
#define posielaj        //povoli posielanie nameranych dat
#define read_enable    //povoli prerusenie od seriovej linky
#define maly_kod
//velkost buffra serioveho prenosu
#define	TX1_buf_size		32
#define	RX1_buf_size		16

//enables pc mastere
#define  pc_master_on

#define auto_range_on_i
#define auto_range_on_u

/*typedef struct
{
	Frac16 A,cos,sin;
}Harm_vysledok;
*/
//ofsety
 volatile int 
U1_offset[]={14098,14070,14042,13782},
U2_offset[]={14105,14068,14036,13739},
U3_offset[]={14058,14040,14054,14188},
I1_offset[]={14098,14087,14083,14087},
I2_offset[]={13945,13910,13873,13635},
I3_offset[]={14079,14068,14072,14091};


const float 
U_maxima[4]={1703.761397	,	806.4870631	,	440.2704656	,	80.89365681},


I_maxima[4]={123	,	40.68	,	18.652	,	4.04},
P_maxima[4][4]={										
{	210022.6674	,	69309.01364	,	31778.55758	,	6883.196045	},
{	99415.66027	,	32807.89373	,	15042.5967	,	3258.207735	},
{	54272.1403	,	17910.20254	,	8211.924725	,	1778.692681	},
{	9971.761075	,	3290.753959	,	1508.828487	,	326.8103735	}
};								
									

			
const Frac16 
prepocet_scale_u[3][4]=
{
{	32503	,	32309	,	32451	,	32767	},
{	32767	,	32498	,	32595	,	32515	},
{	32595	,	32767	,	32767	,	32767	}
},								
								


 prepocet_scale_i[3][4]=
{
{	32767	,	32590	,	32423	,	32767	},
{	32767	,	32767	,	32767	,	32767	},
{	32591	,	32495	,	32767	,	32767	}
},								

prepocet_priemer_i[4][4]={										
{	10922	,	0	,	0	,	0	},		
{	3604	,	10922	,	0	,	0	},		//rozsah 
{	1653	,	5008	,	10922	,	0	},		//maximalny rozsah  ->
{	358	,	1085	,	2366	,	10922	}		
},										

prepocet_priemer_u[4][4]={										
{	10922	,	0	,	0	,	0	},
{	5170	,	10922	,	0	,	0	},
{	2822	,	5963	,	10922	,	0	},
{	519	,	1096	,	2007	,	10922	}

},								
								

prepocet_priemer_pi[4][4]={								
{	32767	,	0	,	0	,	0	},
{	10812	,	32767	,	0	,	0	},
{	4959	,	15024	,	32767	,	0	},
{	1074	,	3255	,	7098	,	32767	}
},								
								
prepocet_priemer_pu[4][4]={								
{	32767	,	0	,	0	,	0	},
{	15510	,	32767	,	0	,	0	},
{	8466	,	17889	,	32767	,	0	},
{	1557	,	3288	,	6021	,	32767	}
};								

//ktory pin ADC je co
#define U1_pin	2
#define I1_pin	1
#define	U2_pin	6
#define	U3_pin	7
#define	I2_pin	5
#define	I3_pin	4
#define	CV_pin	0


/*
prerusenie pre pcmaster
pcmasterRxTxIsr 	level1 	off
pcmasterRxTxIsr 	level2 	on
pcmasterRxErrorIsr 	level1 	on
*/


typedef struct
{
 Frac16 
//efektivne
U1_rms,U2_rms,U3_rms,U_rms,
I1_rms,I2_rms,I3_rms,I_rms, 
//maximalne hodnoty
U1_max,U2_max,U3_max,U_max,
I1_max,I2_max,I3_max,I_max,
//minimalne hodnoty
U1_min,U2_min,U3_min,U_min,
I1_min,I2_min,I3_min,I_min,
//stredne 
U1_avg,U2_avg,U3_avg,U_avg,
I1_avg,I2_avg,I3_avg,I_avg,
//stredne usm. hodnoty
U1_avg_rec,U2_avg_rec,U3_avg_rec,U_avg_rec,
I1_avg_rec,I2_avg_rec,I3_avg_rec,I_avg_rec,
 //vypocitavane veliciny - vykony
P1,P2,P3,P,
S1,S2,S3,S,
Q1,Q2,Q3,Q,
D1,D2,D3,D,
//kosinus fi
cos1,cos2,cos3,cos;	
}Veliciny;

typedef struct
{
unsigned int adr1,adr2,adr3,adr,auto1,auto2,auto3;
}Adresy;


Adresy au,ai,dau,dai;
volatile Veliciny n,d,h,dh;

volatile Frac16 
//namerane hodnoty
U1,I1,U2,I2,U3,I3,CV,
//pole nameranych a vyfiltrovanych hodnot pre vypocet Q
U1n[N],U2n[N],U3n[N],
I1n[N],I2n[N],I3n[N],
//konstanty filtrov
filter_u1=FRAC16(0),
filter_u2=0,
filter_u3=0,
filter_i1=FRAC16(0),
filter_i2=0,
filter_i3=0,
filter_cv=FRAC16(0.9),
//filtrovane namerane hodnory
U1_f,I1_f,U2_f,I2_f,U3_f,I3_f,CV_f,


//pomocne premenne pri hladani minim
U1_min1=FRAC16(1),
I1_min1=FRAC16(1),
U2_min1=FRAC16(1),
I2_min1=FRAC16(1),
U3_min1=FRAC16(1),
I3_min1=FRAC16(1),
//a maxim
U1_max1=0,
I1_max1=0,
U2_max1=0,
I2_max1=0,
U3_max1=0,
I3_max1=0;

//premenne pre sumy pri vypoctoch
volatile Frac32 
sum_Q1=0,sum_Q2=0,sum_Q3=0,
//sum_I1_rms_32,I1_rms_32,I1_f_32,
sum_I1_avg=0,sum_I1_rms=0,sum_I1_avg_rec,
sum_I2_avg=0,sum_I2_rms=0,sum_I2_avg_rec,
sum_I3_avg=0,sum_I3_rms=0,sum_I3_avg_rec,
sum_U1_avg=0,sum_U1_rms=0,sum_U1_avg_rec,
sum_U2_avg=0,sum_U2_rms=0,sum_U2_avg_rec,
sum_U3_avg=0,sum_U3_rms=0,sum_U3_avg_rec,
P1_p,P2_p,P3_p,P_p,
sum_P1=0,sum_P2=0,sum_P3=0;
//adresovanie multiplexorov

volatile UWord16
k_harm=1; // k-ta harmonicka ktora sa ma pocitat

volatile UWord16 zobrazenie=0,riadok=0;



volatile float U1_maximum,U2_maximum,U3_maximum,U_maximum,
			   I1_maximum,I2_maximum,I3_maximum,I_maximum,
			   P1_maximum,P2_maximum,P3_maximum,
			   P_maximum,S_maximum,Q_maximum,D_maximum	;
			   
//konstanty pre DFT - sinusovka a kosinusovka
const Frac16
co1[N]={32767,32729,32610,32413,32138,31786,31357,30853,30274,29622,
		28899,28106,27246,26320,25330,24279,23170,22006,20788,19520,
		18205,16846,15447,14010,12540,11039,9512,7962,6393,4808,3212,
		1608,0,-1608,-3212,-4808,-6393,-7962,-9512,-11039,-12540,-14010,
		-15447,-16846,-18205,-19520,-20788,-22006,-23170,-24279,-25330,
		-26320,-27246,-28106,-28899,-29622,-30274,-30853,-31357,-31786,
		-32138,-32413,-32610,-32729,-32768,-32729,-32610,-32413,-32138,
		-31786,-31357,-30853,-30274,-29622,-28899,-28106,-27246,-26320,
		-25330,-24279,-23170,-22006,-20788,-19520,-18205,-16846,-15447,
		-14010,-12540,-11039,-9512,-7962,-6393,-4808,-3212,-1608,0,1608,
		3212,4808,6393,7962,9512,11039,12540,14010,15447,16846,18205,19520,
		20788,22006,23170,24279,25330,26320,27246,28106,28899,29622,30274,
		30853,31357,31786,32138,32413,32610,32729},

si1[N]={0,1608,3212,4808,6393,7962,9512,11039,12540,14010,15447,16846,
		18205,19520,20788,22006,23170,24279,25330,26320,27246,28106,28899,
		29622,30274,30853,31357,31786,32138,32413,32610,32729,32767,32729,
		32610,32413,32138,31786,31357,30853,30274,29622,28899,28106,27246,
		26320,25330,24279,23170,22006,20788,19520,18205,16846,15447,14010,
		12540,11039,9512,7962,6393,4808,3212,1608,0,-1608,-3212,-4808,-6393,
		-7962,-9512,-11039,-12540,-14010,-15447,-16846,-18205,-19520,-20788,
		-22006,-23170,-24279,-25330,-26320,-27246,-28106,-28899,-29622,-30274,
		-30853,-31357,-31786,-32138,-32413,-32610,-32729,-32768,-32729,-32610
		,-32413,-32138,-31786,-31357,-30853,-30274,-29622,-28899,-28106,-27246,
		-26320,-25330,-24279,-23170,-22006,-20788,-19520,-18205,-16846,-15447,
		-14010,-12540,-11039,-9512,-7962,-6393,-4808,-3212,-1608};


//buffre pre harm. anal.
volatile Frac16
I1_n[N],U1_n[N],
I2_n[N],U2_n[N],
I3_n[N],U3_n[N],
*u1=U1_n,*i1=I1_n,
*u2=U2_n,*i2=I2_n,
*u3=U3_n,*i3=I3_n;

unsigned int dfrek_U1,frek_U1,over_limit;
#define over_voltage  	0b00101000
#define under_voltage 	0b00011000
#define over_current	0b00100100
#define under_current	0b00010100

//seriovy prenos
volatile UWord16  
RX1_buffer[RX1_buf_size],
TX1_buffer[TX1_buf_size],
*TX1_buf_ptr=TX1_buffer,						
 RX1_ptr=0,TX1_ptr=0, //ukazovatele na aktualnu poziciu v buff
//rozne priznaky
 TX1_on,PC_request=false,AT_request,fcn=0,flag_500us=false, 
 harm_on=false,mozes_prepisat=true,fft_stats=empty,poslif=false;
 
//pocitadla
volatile UWord16 pocitadlo=0,pocitadlo_r=0,pocitadlo_500us=0;



typedef struct
{
	Frac16 A,cos,sin;
}Harm_vysledok;

typedef struct
{
	unsigned int u,i;
}adresa_vykon;

adresa_vykon adr_P,adr_Q,adr_D,adr_S;

volatile Harm_vysledok 
vysl_h_i1,vysl_h_u1,
vysl_h_i2,vysl_h_u2,
vysl_h_i3,vysl_h_u3;








			   