/********************************************************************
 *                                                                  *
 * Motorola Inc.                                                    *
 * (c) Copyright 2002 Motorola, Inc.                                *
 * ALL RIGHTS RESERVED.                                             *
 *                                                                  *
 ********************************************************************
 *                                                                  *
 * File Name: mclib.h                                               *
 *                                                                  *
 ********************************************************************/
#ifndef __MCLIB_H
#define __MCLIB_H

#include "types.h"      /* general data definitions                 */ 
#include "mc.h"         /* motor control specific data definition   */

/* include header files of motor control library functions          */ 
#include "basic.h"      /* basic operations definitons              */
#include "transform.h"  /* basic transformations definitions        */  
#include "controller.h" /* controller definitions                   */
#include "resolver.h"   /* resolver driver definitions              */
#include "sincos.h"     /* sin/cos driver definitions               */
#include "svm.h"        /* space vector modulation definitions      */
										
#endif  /* __MCLIB_H */ 

