/************************************************************************
 *                                                                      *
 * Motorola, Inc.                                                       *
 * (c) Copyright 2002 Motorola, Inc.                                    *
 * ALL RIGHTS RESERVED                                                  *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 * File name    : transform.h                                           *
 *                                                                      *
 ************************************************************************/
#ifndef _TRANSFORM_H_
#define _TRANSFORM_H_

/* External function prototype(s)                                       */
extern void MCLIB_ClarkTrfm    (mc_sPhase *pAlphaBeta, mc_s3PhaseSystem *p_abc);
extern void MCLIB_ClarkTrfmInv (mc_s3PhaseSystem *p_abc, mc_sPhase *pAlphaBeta);
extern void MCLIB_ParkTrfm     (mc_sDQsystem *pDQ, mc_sPhase *pAlphaBeta, mc_sAngle *pSinCos);
extern void MCLIB_ParkTrfmInv  (mc_sPhase *pAlphaBeta, mc_sDQsystem *pDQ, mc_sAngle *pSinCos);

#endif

